<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRefueling ArrayType
 * @subpackage Arrays
 */
class ArrayOfRefueling extends AbstractStructArrayBase
{
    /**
     * The Refueling
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Refueling[]
     */
    public $Refueling;
    /**
     * Constructor method for ArrayOfRefueling
     * @uses ArrayOfRefueling::setRefueling()
     * @param \StructType\Refueling[] $refueling
     */
    public function __construct(array $refueling = array())
    {
        $this
            ->setRefueling($refueling);
    }
    /**
     * Get Refueling value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Refueling[]|null
     */
    public function getRefueling()
    {
        return isset($this->Refueling) ? $this->Refueling : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRefueling method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRefueling method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRefuelingForArrayConstraintsFromSetRefueling(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRefuelingRefuelingItem) {
            // validation for constraint: itemType
            if (!$arrayOfRefuelingRefuelingItem instanceof \StructType\Refueling) {
                $invalidValues[] = is_object($arrayOfRefuelingRefuelingItem) ? get_class($arrayOfRefuelingRefuelingItem) : sprintf('%s(%s)', gettype($arrayOfRefuelingRefuelingItem), var_export($arrayOfRefuelingRefuelingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Refueling property can only contain items of type \StructType\Refueling, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Refueling value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Refueling[] $refueling
     * @return \ArrayType\ArrayOfRefueling
     */
    public function setRefueling(array $refueling = array())
    {
        // validation for constraint: array
        if ('' !== ($refuelingArrayErrorMessage = self::validateRefuelingForArrayConstraintsFromSetRefueling($refueling))) {
            throw new \InvalidArgumentException($refuelingArrayErrorMessage, __LINE__);
        }
        if (is_null($refueling) || (is_array($refueling) && empty($refueling))) {
            unset($this->Refueling);
        } else {
            $this->Refueling = $refueling;
        }
        return $this;
    }
    /**
     * Add item to Refueling value
     * @throws \InvalidArgumentException
     * @param \StructType\Refueling $item
     * @return \ArrayType\ArrayOfRefueling
     */
    public function addToRefueling(\StructType\Refueling $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Refueling) {
            throw new \InvalidArgumentException(sprintf('The Refueling property can only contain items of type \StructType\Refueling, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Refueling[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Refueling|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Refueling|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Refueling|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Refueling|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Refueling|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Refueling
     */
    public function getAttributeName()
    {
        return 'Refueling';
    }
}
